//
//  SceneDelegate.swift
//  Example
//
//  Created by Shivangi Goel on 23/12/21.
//

import UIKit
import GluedInSDK

class SceneDelegate: UIResponder, UIWindowSceneDelegate {
    
    var window: UIWindow?
    
    @available(iOS 13.0, *)
    func scene(
        _ scene: UIScene,
        willConnectTo session: UISceneSession,
        options connectionOptions: UIScene.ConnectionOptions
    ) {
        //guard let windowScene = scene as? UIWindowScene else { return }
        guard let windowScene = scene as? UIWindowScene else { return }
        window = UIWindow(windowScene: windowScene)
        window?.rootViewController = UIStoryboard(name: "Main", bundle: nil).instantiateInitialViewController()
        window?.makeKeyAndVisible()
        
//        GluedIn.shared.initSdk {
//            let gluedinTab:UITabBarController = GluedIn.shared.rootTabController() ?? UITabBarController()
//            self.window?.rootViewController = gluedinTab
//        } failure: { error, code in
//            print(error)
//        }

        
//        GluedIn.shared.initSdk { [weak self] in
//            guard let weakSelf = self else { return }
//            let rootController =  GluedIn.shared.rootControllerWithSignIn()
//            let navigationController = UINavigationController(rootViewController: rootController ?? UIViewController())
//            weakSelf.window?.rootViewController = navigationController
//        } failure: { error,arg  in
//            print(error)
//            print(arg)
//        }
    }
    
    @available(iOS 13.0, *)
    func sceneDidDisconnect(_ scene: UIScene) {
        // Called as the scene is being released by the system.
        // This occurs shortly after the scene enters the background, or when its session is discarded.
        // Release any resources associated with this scene that can be re-created the next time the scene connects.
        // The scene may re-connect later, as its session was not necessarily discarded (see `application:didDiscardSceneSessions` instead).
    }
    
    @available(iOS 13.0, *)
    func sceneDidBecomeActive(_ scene: UIScene) {
        // Called when the scene has moved from an inactive state to an active state.
        // Use this method to restart any tasks that were paused (or not yet started) when the scene was inactive.
    }
    
    @available(iOS 13.0, *)
    func sceneWillResignActive(_ scene: UIScene) {
        // Called when the scene will move from an active state to an inactive state.
        // This may occur due to temporary interruptions (ex. an incoming phone call).
    }
    
    @available(iOS 13.0, *)
    func sceneWillEnterForeground(_ scene: UIScene) {
        // Called as the scene transitions from the background to the foreground.
        // Use this method to undo the changes made on entering the background.
    }
    
    @available(iOS 13.0, *)
    func sceneDidEnterBackground(_ scene: UIScene) {
        // Called as the scene transitions from the foreground to the background.
        // Use this method to save data, release shared resources, and store enough scene-specific state information
        // to restore the scene back to its current state.
    }
    
    @available(iOS 13.0, *)
    func scene(_ scene: UIScene, openURLContexts URLContexts: Set<UIOpenURLContext>) {
        guard let url = URLContexts.first?.url else {
            return
        }
        SocialManager.sharedInstance.tryHandleSocialCallbackForSceneDelegate(url: url)
    }
    
}

